package cn.wzpmc.commerce.entities;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Arrays;
import java.util.Comparator;
import java.util.List;

@EqualsAndHashCode(callSuper = true)
@AllArgsConstructor
@Data
public class MerchantUser extends User {
    private Integer countDown;
    private List<Order> orders;
    private List<MerchantUserCommission> commissions;

    public void calcOrderCommission() {
        MerchantUserCommission[] array = commissions.toArray(new MerchantUserCommission[]{});
        Arrays.sort(array, Comparator.comparingDouble(MerchantUserCommission::getPriceMin));
        orderFor:
        for (Order order : orders) {
            double price = order.getPayAmt();
            for (MerchantUserCommission commission : array) {
                if (price >= commission.getPriceMin() && price <= commission.getPriceMax()) {
                    order.setCommission(price * commission.getCommission());
                    continue orderFor;
                }
            }
            order.setCommission(0);
        }
    }
}
