package cn.wzpmc.commerce.utils;

import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.JSONWriter;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.SneakyThrows;

import java.io.OutputStream;
import java.nio.charset.StandardCharsets;
import java.util.Date;

@Data
@AllArgsConstructor
public class MessageResponse {
    private String msg;
    private int code;
    private long timestamp;

    public MessageResponse() {
        this.code = 200;
        this.msg = "成功";
        this.timestamp = new Date().getTime();
    }

    public MessageResponse(String msg) {
        this(msg, 200);
    }

    public MessageResponse(String msg, int code) {
        this(msg, code, new Date().getTime());
    }

    public String toString() {
        return JSONObject.from(this).toJSONString(JSONWriter.Feature.IgnoreNonFieldGetter);
    }

    @SneakyThrows
    public void copyToStream(OutputStream stream) {
        stream.write(this.toString().getBytes(StandardCharsets.UTF_8));
    }
}
