package cn.wzpmc.commerce.utils;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

@EqualsAndHashCode(callSuper = true)
@Data
public class PageableResponse<T> extends DataResponse<PageableResponse.PageableData<T>> {
    public PageableResponse(List<T> data, long total) {
        this(new PageableData<>(data, total));
    }

    public PageableResponse(PageableData<T> data) {
        super(data);
    }

    public static <T> PageableResponse<T> of(Page<T> pageResult) {
        return new PageableResponse<>(PageableData.of(pageResult));
    }

    @Data
    @AllArgsConstructor
    public static class PageableData<T> {
        private List<T> info;
        private long total;

        public static <T> PageableData<T> of(Page<T> pageResult) {
            return new PageableData<>(pageResult.getRecords(), pageResult.getTotal());
        }
    }
}
